﻿KKBK_VERSION = "0.3 beta"
KKBK_NAME_VERSION = "KKBK "..KKBK_VERSION
kkbk_class = {}
MY_CLASS = ""
MY_CLASS_LOCALIZED = ""
CURRENT_CLASS = ""
addon_is_loaded = false
BUFFS = {}
ui_elements = {
    player_names = {},
    checkbox = {}
}
current_page = ""
pages = {}
is_raid_init = false

-- we suppose max 10 player from the same class
MAX_PLAYERS = 10
-- number of groups
MAX_GROUPS = 8

SUPPORTED_CLASSES = { "PRIEST", "MAGE", "DRUID", "PALADIN" }

function supported_class(cl) 
    for _, v in SUPPORTED_CLASSES do
        if cl == v then
            return true
        end
    end
    return false
end

function kkbk_onLoad()    
    playerClass, englishClass = UnitClass("player")
    MY_CLASS = englishClass
	MY_CLASS_LOCALIZED = playerClass
    if DEBUG then
        MY_CLASS = "PALADIN"
    end
    
    if not supported_class(MY_CLASS) then
        CURRENT_CLASS = SUPPORTED_CLASSES[1]
    else 
        CURRENT_CLASS = MY_CLASS
    end
    
    this:RegisterEvent("ADDON_LOADED")
    this:RegisterEvent("CHAT_MSG_WHISPER")
    
	SLASH_KKBK1 = "/kkbk"
	SlashCmdList["KKBK"] = kkbk_toggleFrame
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00KikiBufKoi "..KKBK_VERSION.." " .. LOADED .. ".|r")
    DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..ENTER_SLASH .. ".|r")
    
    -- Allows kkbk to be closed with the Escape key (found in atlas code ^^)
	tinsert(UISpecialFrames, "kkbk_MainFrame");
end

local group_x = 10
local group_y = -5
local right_pos = 100
local top_pos = -25
local y_line = 4
local x_line = 2

function kkbk_InitUI()
    -- place players
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i] = CreateFrame("Frame", "player_label_"..i, kkbk_MainFramePanel2, "kkbk_label_player_template");
        local label = ui_elements["player_names"][i]
        label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, top_pos + (group_y * (i * y_line)));
        getglobal("player_label_"..i.."Text"):SetText("player"..i)
        label:Hide()
    end
    
    -- place group labels
    local group = CreateFrame("Frame", "group_names", kkbk_MainFramePanel2, "kkbk_label_group_template");
    group:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , group_x, group_y);
    getglobal("group_namesText"):SetText(GROUP)
    
    for i=1, MAX_GROUPS do
        local label = CreateFrame("Frame", "group_label_"..i, kkbk_MainFramePanel2, "kkbk_label_group_num_template");
        label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , right_pos + (group_x * (i * x_line)), group_y);
        getglobal("group_label_"..i.."Text"):SetText(""..i)
    end
    
    -- place checkboxes
    for i=1, MAX_PLAYERS do
        ui_elements["checkbox"][i] = {}
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii] = CreateFrame("CheckButton", "checkbox_"..i.."_"..ii, kkbk_MainFramePanel2, "kkbk_checkbutton_template");
            local label = ui_elements["checkbox"][i][ii]
            local my_x = right_pos + (group_x * (ii * x_line))
            local my_y = top_pos + (group_y * (i * y_line))
            label:SetPoint("TOPLEFT", "kkbk_MainFramePanel2", "TOPLEFT" , my_x, my_y)
            label:Hide()
            
            local vi = i
            local vii = ii
            ui_elements["checkbox"][i][ii] = label
            label:SetScript("OnClick", function() kkbk_checkboxClic(vi, vii) end)
        end
    end
    
    UIDropDownMenu_Initialize(kkbk_chooseClass, kkbk_chooseClass_Initialize);
    local o=1
    for _, v in SUPPORTED_CLASSES do
        if v == MY_CLASS then
            UIDropDownMenu_SetSelectedID(kkbk_chooseClass, o);
            break
        end
        o = o + 1
    end
end

function kkbk_onEvent()
    if event == RAID_ROSTER_UPDATE then
        kkbk_debug("RAID_ROSTER_UPDATE")
    elseif event == "ADDON_LOADED" and strlower(arg1) == "kkbk" then
        if kkbk_options == nil then
	        kkbk_options = CloneTable(kkbk_defaultOptions)
        end
        
        if not kkbk_options["anwser_whisp"] then
            kkbk_options["anwser_whisp"] = true
        end
        kkbk_remapLanguage(kkbk_options["prefered_language"])
        addon_is_loaded = true
        kkbk_UpdatePosition()
        kkbk_minimapInit()
        kkbk_InitUI()
    elseif event == "CHAT_MSG_WHISPER" then
        -- if not in raid then ignore
        if not UnitInRaid("player") then return end
        
        -- arg1 = Message received 
        -- arg2 = Author 
        -- arg6 = status
        if arg1 == KKBK_ASK_BUFF and kkbk_options["anwser_whisp"] then
            kkbk_sendToChan(arg2)
        end
    end
end

function kkbk_page(shortName, longName)
    kkbk_computeThisPage()
    kkbk_debug("changing page : " .. shortName);
    current_page = shortName
    
    if not pages[current_page] then
        pages[current_page] = {}
        for i=1, table.getn(kkbk_class) do
            pages[current_page][i] = {}
            
            if kkbk_isPaladinBuff(current_page) then
                pages[current_page][i][1] = nil
            else 
                for ii=1, MAX_GROUPS do
                    pages[current_page][i][ii] = nil
                end
            end
        end
    end
    
    for i=1, MAX_PLAYERS do
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii]:SetChecked(nil)
        end
    end
    
    for i=1, table.getn(kkbk_class) do
        name = kkbk_class[i]
        if buffs[name] then
            kkbk_debug(name .. " exist")
            if buffs[name][current_page] then
                kkbk_debug(current_page .. " exist")
                for k, v in buffs[name][current_page] do
                    if v == "PALADIN" then
                        ui_elements["checkbox"][i][1]:SetChecked(true)
                    else
                        kkbk_debug(v)
                        ui_elements["checkbox"][i][v]:SetChecked(true)
                    end
                end
            end
        end
    end
    kkbk_buff_name:SetText(longName)
end

function kkbk_checkboxClic(i, ii)
    pages[current_page][i][ii] = true
    for o=1, MAX_PLAYERS do
        if o ~= i and ui_elements["checkbox"][o][ii]:IsVisible() then
            ui_elements["checkbox"][o][ii]:SetChecked(nil)
            pages[current_page][o][ii] = nil
        end
    end
end

function kkbk_toggleFrame()
	if (kkbk_MainFrame:IsVisible()) then
		kkbk_MainFrame:Hide()
	else
		kkbk_MainFrame:Show()
	end	
end

function kkbk_isPaladinBuff(buff)
    local lang = kkbk_options["prefered_language"]
    
    if buff == BUFFS_TEXT[lang]["KING"][2] or buff == BUFFS_TEXT[lang]["WISDOM"][2] 
        or buff == BUFFS_TEXT[lang]["POWER"][2] or buff == BUFFS_TEXT[lang]["LIGHT"][2] 
        or buff == BUFFS_TEXT[lang]["SALUT"][2] then
            return true
    else
        return false
    end
end

--[[ array looks like
buffs = {
    ["player 1"] = { -- player 1 is a priest
        ["Stamina"] = { 1, 2, 3, 4 },
        ["Spirit"] = { 3, 4}
    },
    ["player 2"] = { -- player 2 is a paladin
        ["King"] = { "PALADIN" },
    }
}
]]
buffs = {}

function kkbk_computeThisPage() 
    for page, arr in pages do
        for player, groups in arr do
            local group_to_buff = {}
            
            for group, buff in groups do
                if buff ~= nil then
                    if kkbk_isPaladinBuff(page) then
                        table.insert(group_to_buff, "PALADIN")
                    else
                        table.insert(group_to_buff, group)
                        table.sort(group_to_buff)
                    end
                end
            end
    
            if kkbk_tcount(group_to_buff) > 0 then
                kkbk_debug(player)
                name = kkbk_class[player]

                if not buffs[name] then
                    buffs[name] = {}
                end
                if not buffs[name][page] then
                    buffs[name][page] = {}
                end
                buffs[name][page] = group_to_buff 
            end
        end
    end
end

function kkbk_sendToChan(from_whisp)   
    kkbk_computeThisPage()    
    
    if kkbk_tcount(buffs) > 0 then    
        local message = {}
        
        for player, arr in buffs do
            local strg = "[" .. player .. "] "
            
            for buff, groups in arr do
                if groups[1] == "PALADIN" then
                    strg = strg .. " => " .. buff
                else
                    strg = strg .. buff .. " => [" .. table.concat(groups, ", ") .. "] "
                end
            end
            
            if not kkbk_options["separate_line"] then
                if not message[1] then
                    message[1] = strg
                else
                    message[1] = message[1] .. " " .. strg
                end
            else
                table.insert(message, strg)
            end
        end
        
        for _, lines in message do
            if from_whisp ~= nil then
                SendChatMessage(lines, "WHISPER", nil, from_whisp)
            else
                if kkbk_options["channel"]["is_raid"] then
                    SendChatMessage(lines, "RAID", nil)
                elseif kkbk_options["channel"]["is_group"] then
                    SendChatMessage(lines, "PARTY", nil)
                elseif kkbk_options["channel"]["is_channel"] then
                id, name = GetChannelName(kkbk_options["channel"]["channel"])
                    SendChatMessage(lines, "CHANNEL", nil, id)
                end
            end
        end
    end
end

function kkbk_resetEvent()
    kkbk_reset()    
    pages = {}
    kkbk_initRaid()
end

function kkbk_getLongName(short)
    for key, value in BUFFS[MY_CLASS] do
        if value.shortName == short then
            return value.longName
        end
    end
    return ""
end

function kkbk_reset()
    is_raid_init = false
    kkbk_class = {}
    for i=1, MAX_PLAYERS do
        ui_elements["player_names"][i]:Hide()
        for ii=1, MAX_GROUPS do
            ui_elements["checkbox"][i][ii]:Hide()
            ui_elements["checkbox"][i][ii]:SetChecked(nil)
        end
    end
end

function kkbk_getRaidMembers()
    -- getting all players from selected class
    if DEBUG then
        -- for debug mode, I use people from my own guild
        if CURRENT_CLASS == "PALADIN" then
            kkbk_class = { "Gladiateur", "Nocif", "Coinette", "Halgrim", "Ulrich"}
        elseif CURRENT_CLASS == "PRIEST" then
            kkbk_class = { "Lateria", "Elyxsir", "Pristina", "Khardinal", "Frereantho", "Reiko"}
        elseif CURRENT_CLASS == "MAGE" then
            kkbk_class = { "Kiliana", "Opi", "Tarmani", "Cenaryus"}
        elseif CURRENT_CLASS == "DRUID" then
            kkbk_class = { "Belldand", "Thegrimreaper", "Piqueplume"}
        end
    else
	    local o=1
        for i=1, GetNumRaidMembers() do
            name = GetRaidRosterInfo(i)
            if name ~= nil then
                playerClass, englishClass = UnitClass("raid"..i);
                if englishClass ~= nil and playerClass ~= nil then
                    if englishClass == CURRENT_CLASS then
                        kkbk_class[o] = name
                        kkbk_debug("add "..name.." to " ..playerClass)
			            o = o + 1
                    end
                end
            end
        end
    end
    table.sort(kkbk_class)
end

-- used to hide other buttons
number_of_buff_button = 0

function kkbk_initRaid()    
    if is_raid_init then return end

    kkbk_debug("init raid");
    
    is_raid_init = true
    
    -- get raid members
    kkbk_getRaidMembers()
    
    if CURRENT_CLASS == "PALADIN" then
        getglobal("group_names"):Hide()
        
        for i=1, MAX_GROUPS do
            getglobal("group_label_"..i):Hide()
        end
    else
        getglobal("group_names"):Show()
        
        for i=1, MAX_GROUPS do
            getglobal("group_label_"..i):Show()
        end
    end
    
    -- ok, now we can draw the window
    local i = 1
    for k, v in kkbk_class do
        getglobal(ui_elements["player_names"][i]:GetName().."Text"):SetText(v)
        ui_elements["player_names"][i]:Show()
        if CURRENT_CLASS == "PALADIN" then
            ui_elements["checkbox"][i][1]:Show()
        else
            for ii = 1, MAX_GROUPS do
                ui_elements["checkbox"][i][ii]:Show()
            end
        end
        i = i + 1
    end
    
     local use_btn = 0
    for key, value in BUFFS[CURRENT_CLASS] do
        local button;
        if not getglobal("buff_btn_"..key) then
            button = CreateFrame("Button", "buff_btn_"..key, kkbk_MainFramePanel3, "kkbk_buff_btn_template")
            button:SetPoint("CENTER", "kkbk_MainFramePanel3", "TOP" , 0, 0 - (key * y_line * 6))
        else
            button = getglobal("buff_btn_"..key)
        end
        local shortName = value.shortName
        local longName = value.longName

        button:SetScript("OnClick", function() kkbk_page(shortName, longName) end);
        button:Show()
        button:SetText(value.shortName)
        
        if key == 1 then
            kkbk_page(shortName, longName)
        end
        use_btn = key
    end
    use_btn = use_btn + 1
    if use_btn < number_of_buff_button then
        for i=use_btn, number_of_buff_button do
            getglobal("buff_btn_"..i):Hide()
        end
    end
    number_of_buff_button = use_btn - 1
end

function kkbk_chooseClass_OnClick()
    -- save current class
    kkbk_computeThisPage()
    
    local old_class = CURRENT_CLASS
    
	UIDropDownMenu_SetSelectedID(kkbk_chooseClass, this:GetID(), 0);
    for k, v in CLASS_NAME do
        if v == UIDropDownMenu_GetText(kkbk_chooseClass) then
            CURRENT_CLASS = k
            break
        end
    end
    
    if CURRENT_CLASS == old_class then
        return
    end
    -- reset ui
    pages = {}
    kkbk_reset()
    
    -- init new class
    kkbk_initRaid()
end

function kkbk_chooseClass_OnShow()    
	UIDropDownMenu_SetSelectedID(kkbk_chooseClass, this:GetID(), 0);
end

function kkbk_chooseClass_Initialize()
	local info;
	for i = 1, table.getn(SUPPORTED_CLASSES) do
        local cl = SUPPORTED_CLASSES[i]
		info = {
			text = CLASS_NAME[cl];
			func = kkbk_chooseClass_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end
