﻿supported_languages = {
    { "Fran\195\167ais", "frFR" },
    { "English", "enUS" },
    { "German", "deDE" }
}
kkbk_defaultOptions = {
    separate_line = true,
    prefered_language = GetLocale(),
    channel = {
        is_raid = false,
        is_group = false,
        is_channel = true,
        channel = ""
    },
    minimap_position = 268,
    anwser_whisp = true
}

function kkbk_want_language(lang)
    if kkbk_options == nil or kkbk_options["prefered_language"] == nil then
        return GetLocale() == lang
    elseif kkbk_options["prefered_language"] == lang then
        return true
    end
    
    return false
end

function kkbk_initOptions()
    
end

function kkbk_optionsOpened()
    getglobal(kkbk_separate_lines:GetName() .. "Text"):SetText(KKBK_SEPARATE_LINES)
    kkbk_separate_lines:SetChecked(kkbk_options["separate_line"])
    
    getglobal(kkbk_send_to_raid:GetName() .. "Text"):SetText(KKBK_SEND_TO_RAID)
    kkbk_send_to_raid:SetChecked(kkbk_options["channel"]["is_raid"])
    kkbk_send_to_raid:SetScript("OnClick", function() kkbk_send("raid") end)
        
    getglobal(kkbk_send_to_group:GetName() .. "Text"):SetText(KKBK_SEND_TO_GROUP)
    kkbk_send_to_group:SetChecked(kkbk_options["channel"]["is_group"])
    kkbk_send_to_group:SetScript("OnClick", function() kkbk_send("group") end)
        
    getglobal(kkbk_send_to_channel:GetName() .. "Text"):SetText(KKBK_SEND_TO_CHANNEL)
    kkbk_send_to_channel:SetChecked(kkbk_options["channel"]["is_channel"])
    kkbk_send_to_channel:SetScript("OnClick", function() kkbk_send("channel") end)
    
    kkbk_chan:SetText(kkbk_options["channel"]["channel"])
    
    getglobal(kkbk_SliderButtonPos:GetName().."Text"):SetText(KKBK_OPTIONS_BUTPOS)
    getglobal(kkbk_SliderButtonPos:GetName().."High"):SetText("360")
    getglobal(kkbk_SliderButtonPos:GetName().."Low"):SetText("0")
    kkbk_SliderButtonPos:SetMinMaxValues(0,360)
    kkbk_SliderButtonPos:SetValueStep(1)
    kkbk_SliderButtonPos:SetValue(kkbk_options["minimap_position"])
    
    UIDropDownMenu_Initialize(LanguageChoose, kkbk_DropDown_Initialize);
    local o=1
    for _, arr in supported_languages do
        if arr[2] == kkbk_options["prefered_language"] then
            UIDropDownMenu_SetSelectedID(LanguageChoose, o);
            break
        end
        o = o + 1
    end
    
    getglobal(kkbk_anwser_whisp:GetName() .. "Text"):SetText(KKBK_ANWSER_WHISP)
    kkbk_anwser_whisp:SetChecked(kkbk_options["anwser_whisp"])
    
end

function kkbk_send(var)
    if var == "raid" then
        kkbk_send_to_group:SetChecked(nil)
        kkbk_send_to_channel:SetChecked(nil)
    elseif var == "group" then
        kkbk_send_to_raid:SetChecked(nil)
        kkbk_send_to_channel:SetChecked(nil)
    elseif var == "channel" then
        kkbk_send_to_group:SetChecked(nil)
        kkbk_send_to_raid:SetChecked(nil)
    end
end

function kkbk_applyOptions()
    kkbk_options["separate_line"] = kkbk_separate_lines:GetChecked()
    
    kkbk_options["channel"]["is_raid"] = kkbk_send_to_raid:GetChecked() or false
    kkbk_options["channel"]["is_group"] = kkbk_send_to_group:GetChecked() or false
    kkbk_options["channel"]["is_channel"] = kkbk_send_to_channel:GetChecked() or false
    kkbk_options["channel"]["channel"] = kkbk_chan:GetText() or ""
    kkbk_options["anwser_whisp"] = kkbk_anwser_whisp:GetChecked() or false
    
    for _, arr in supported_languages do
        if arr[1] == UIDropDownMenu_GetText(LanguageChoose) then            
            if kkbk_options["prefered_language"] ~= arr[2] then
                UIErrorsFrame:AddMessage(MUST_RESTART, 1.0, 0.0, 0.0, 1.0, 5);
                DEFAULT_CHAT_FRAME:AddMessage(KKBK_NAME_VERSION.." : " ..MUST_RESTART)
            end
            kkbk_options["prefered_language"] = arr[2]
            break
        end
    end
    
    kkbk_toggleOptions()
end

function kkbk_remapLanguage(lang)   
    BUFFS["PRIEST"] = {
        { longName = BUFFS_TEXT[lang]["FORTITUDE"][1], shortName = BUFFS_TEXT[lang]["FORTITUDE"][2]},
        { longName = BUFFS_TEXT[lang]["SPIRIT"][1], shortName = BUFFS_TEXT[lang]["SPIRIT"][2]},
        { longName = BUFFS_TEXT[lang]["SHADOW"][1], shortName = BUFFS_TEXT[lang]["SHADOW"][2]}
    }
    BUFFS["DRUID"] = {
        { longName = BUFFS_TEXT[lang]["MARKOFWILD"][1], shortName = BUFFS_TEXT[lang]["MARKOFWILD"][2]},
        { longName = BUFFS_TEXT[lang]["THORNS"][1], shortName = BUFFS_TEXT[lang]["THORNS"][2]},
    }
    BUFFS["MAGE"] = {
        { longName = BUFFS_TEXT[lang]["INTELLECT"][1], shortName = BUFFS_TEXT[lang]["INTELLECT"][2]},
    }
    BUFFS["PALADIN"] = {
        { longName = BUFFS_TEXT[lang]["KING"][1], shortName = BUFFS_TEXT[lang]["KING"][2]},
        { longName = BUFFS_TEXT[lang]["WISDOM"][1], shortName = BUFFS_TEXT[lang]["WISDOM"][2]},
        { longName = BUFFS_TEXT[lang]["POWER"][1], shortName = BUFFS_TEXT[lang]["POWER"][2]},
        { longName = BUFFS_TEXT[lang]["LIGHT"][1], shortName = BUFFS_TEXT[lang]["LIGHT"][2]},
        { longName = BUFFS_TEXT[lang]["SALUT"][1], shortName = BUFFS_TEXT[lang]["SALUT"][2]},
    }
end

function kkbk_toggleOptions()
    if (kkbk_OptionFrame:IsVisible()) then
		kkbk_OptionFrame:Hide()
	else
		kkbk_OptionFrame:Show()
	end
end

function kkbk_DropDown_OnClick()
	UIDropDownMenu_SetSelectedID(LanguageChoose, this:GetID(), 0);
end

function kkbk_DropDown_OnShow()    
	UIDropDownMenu_SetSelectedID(LanguageChoose, this:GetID(), 0);
end

function kkbk_DropDown_Initialize()
	local info;
	for i = 1, table.getn(supported_languages) do
		info = {
			text = supported_languages[i][1];
			func = kkbk_DropDown_OnClick;
		};
		UIDropDownMenu_AddButton(info);
	end
end
